using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace EnumerableDemo
{
    class Program
    {
        static int SimpleReturn()
        {
            return 1;
            return 2;
            return 3;
        }

        static IEnumerable<int> YieldReturn()
        {
            yield return 1;
            yield return 2;
            yield return 3;
        }

        static void Main(string[] args)
        {
            // Let us first see how we can enumerate an object implementing IEnumerable
            ArrayList list = new ArrayList();

            list.Add("1");
            list.Add(2);
            list.Add("3");
            list.Add('4');

            foreach (object s in list)
            {
                Console.WriteLine(s);
            }

            // Let us first see how we can enumerate an object implementing IEnumerable<T>
            List<string> listOfStrings = new List<string>();

            listOfStrings.Add("one");
            listOfStrings.Add("two");
            listOfStrings.Add("three");
            listOfStrings.Add("four");

            foreach (string s in listOfStrings)
            {
                Console.WriteLine(s);
            }

            Console.WriteLine();

            // Lets see how simeple return works
            Console.WriteLine(SimpleReturn());
            Console.WriteLine(SimpleReturn());
            Console.WriteLine(SimpleReturn());
            Console.WriteLine(SimpleReturn());

            // Lets see how yield return works
            foreach (int i in YieldReturn())
            {
                Console.WriteLine(i);
            }

            Console.WriteLine();
            //Let us now go ahead and use our custom MyArrayList with IEnumerable implemented
            MyArrayList myList = new MyArrayList();

            myList.Add("1");
            myList.Add(2);
            myList.Add("3");
            myList.Add('4');

            foreach (object s in myList)
            {
                Console.WriteLine(s);
            }

            // Let us first see how we can enumerate an custom MyList<T> class implementing IEnumerable<T>
            MyList<string> myListOfStrings = new MyList<string>();

            myListOfStrings.Add("one");
            myListOfStrings.Add("two");
            myListOfStrings.Add("three");
            myListOfStrings.Add("four");

            foreach (string s in myListOfStrings)
            {
                Console.WriteLine(s);
            }
        }
    }
}
